chiark / gitweb /
tg-delete: Handle the case where the branch has been removed already, but the base...
[topgit.git] / tg.sh
1 #!/bin/sh
2 # TopGit - A different patch queue manager
3 # (c) Petr Baudis <pasky@suse.cz>  2008
4 # GPLv2
5
6 TG_VERSION=0.8
7
8 ## Auxiliary functions
9
10 info()
11 {
12         echo "${TG_RECURSIVE}tg: $*"
13 }
14
15 die()
16 {
17         info "fatal: $*"
18         exit 1
19 }
20
21 # cat_file "topic:file"
22 # Like `git cat-file blob $1`, but topics '(i)' and '(w)' means index and worktree
23 cat_file()
24 {
25         arg="$1"
26         case "$arg" in
27         '(w):'*)
28                 arg=$(echo "$arg" | tail --bytes=+5)
29                 cat "$arg"
30                 return
31                 ;;
32         '(i):'*)
33                 # ':file' means cat from index
34                 arg=$(echo "$arg" | tail --bytes=+5)
35                 git cat-file blob ":$arg"
36                 ;;
37         *)
38                 git cat-file blob "$arg"
39         esac
40 }
41
42 # setup_hook NAME
43 setup_hook()
44 {
45         hook_call="\"\$($tg --hooks-path)\"/$1 \"\$@\""
46         if [ -f "$git_dir/hooks/$1" ] &&
47            fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
48                 # Another job well done!
49                 return
50         fi
51         # Prepare incantation
52         if [ -x "$git_dir/hooks/$1" ]; then
53                 hook_call="$hook_call"' || exit $?'
54         else
55                 hook_call="exec $hook_call"
56         fi
57         # Insert call into the hook
58         {
59                 echo "#!/bin/sh"
60                 echo "$hook_call"
61                 [ ! -s "$git_dir/hooks/$1" ] || cat "$git_dir/hooks/$1"
62         } >"$git_dir/hooks/$1+"
63         chmod a+x "$git_dir/hooks/$1+"
64         mv "$git_dir/hooks/$1+" "$git_dir/hooks/$1"
65 }
66
67 # setup_ours (no arguments)
68 setup_ours()
69 {
70         if [ ! -s "$git_dir/info/attributes" ] || ! grep -q topmsg "$git_dir/info/attributes"; then
71                 {
72                         echo ".topmsg   merge=ours"
73                         echo ".topdeps  merge=ours"
74                 } >>"$git_dir/info/attributes"
75         fi
76         if ! git config merge.ours.driver >/dev/null; then
77                 git config merge.ours.name '"always keep ours" merge driver'
78                 git config merge.ours.driver 'touch %A'
79         fi
80 }
81
82 # measure_branch NAME [BASE]
83 measure_branch()
84 {
85         _bname="$1"; _base="$2"
86         [ -n "$_base" ] || _base="refs/top-bases/$_bname"
87         # The caller should've verified $name is valid
88         _commits="$(git rev-list "$_bname" ^"$_base" -- | wc -l)"
89         _nmcommits="$(git rev-list --no-merges "$_bname" ^"$_base" -- | wc -l)"
90         if [ $_commits -gt 1 ]; then
91                 _suffix="commits"
92         else
93                 _suffix="commit"
94         fi
95         echo "$_commits/$_nmcommits $_suffix"
96 }
97
98 # branch_contains B1 B2
99 # Whether B1 is a superset of B2.
100 branch_contains()
101 {
102         [ -z "$(git rev-list --max-count=1 ^"$1" "$2" --)" ]
103 }
104
105 # ref_exists REF
106 # Whether REF is a valid ref name
107 ref_exists()
108 {
109         git rev-parse --verify "$@" >/dev/null 2>&1
110 }
111
112 # has_remote BRANCH
113 # Whether BRANCH has a remote equivalent (accepts top-bases/ too)
114 has_remote()
115 {
116         [ -n "$base_remote" ] && ref_exists "remotes/$base_remote/$1"
117 }
118
119 branch_annihilated()
120 {
121         _name="$1";
122
123         # use the merge base in case the base is ahead.
124         mb="$(git merge-base "refs/top-bases/$_name" "$_name")";
125
126         test "$(git rev-parse "$mb^{tree}")" = "$(git rev-parse "$_name^{tree}")";
127 }
128
129 # is_sha1 REF
130 # Whether REF is a SHA1 (compared to a symbolic name).
131 is_sha1()
132 {
133         [ "$(git rev-parse "$1")" = "$1" ]
134 }
135
136 # recurse_deps CMD NAME [BRANCHPATH...]
137 # Recursively eval CMD on all dependencies of NAME.
138 # CMD can refer to $_name for queried branch name,
139 # $_dep for dependency name,
140 # $_depchain for space-seperated branch backtrace,
141 # and the $_dep_is_tgish boolean.
142 # It can modify $_ret to affect the return value
143 # of the whole function.
144 # If recurse_deps() hits missing dependencies, it will append
145 # them to space-separated $missing_deps list and skip them.
146 # remote dependencies are processed if no_remotes is unset.
147 recurse_deps()
148 {
149         _cmd="$1"; shift
150         _name="$1"; # no shift
151         _depchain="$*"
152
153         _depsfile="$(mktemp -t tg-depsfile.XXXXXX)"
154         # If no_remotes is unset check also our base against remote base.
155         # Checking our head against remote head has to be done in the helper.
156         if test -z "$no_remotes" && has_remote "top-bases/$_name"; then
157                 echo "refs/remotes/$base_remote/top-bases/$_name" >>"$_depsfile"
158         fi
159
160         # if the branch was annihilated, there exists no .topdeps file
161         if ! branch_annihilated "$_name"; then
162                 #TODO: handle nonexisting .topdeps?
163                 git cat-file blob "$_name:.topdeps" >>"$_depsfile";
164         fi;
165
166         _ret=0
167         while read _dep; do
168                 if ! ref_exists "$_dep" ; then
169                         # All hope is lost
170                         missing_deps="$missing_deps $_dep"
171                         continue
172                 fi
173
174                 _dep_is_tgish=1
175                 ref_exists "refs/top-bases/$_dep"  ||
176                         _dep_is_tgish=
177
178                 # Shoo shoo, keep our environment alone!
179                 [ -z "$_dep_is_tgish" ] ||
180                         (recurse_deps "$_cmd" "$_dep" "$@") ||
181                         _ret=$?
182
183                 eval "$_cmd"
184         done <"$_depsfile"
185         missing_deps="${missing_deps# }"
186         rm "$_depsfile"
187         return $_ret
188 }
189
190 # branch_needs_update
191 # This is a helper function for determining whether given branch
192 # is up-to-date wrt. its dependencies. It expects input as if it
193 # is called as a recurse_deps() helper.
194 # In case the branch does need update, it will echo it together
195 # with the branch backtrace on the output (see needs_update()
196 # description for details) and set $_ret to non-zero.
197 branch_needs_update()
198 {
199         _dep_base_update=
200         if [ -n "$_dep_is_tgish" ]; then
201                 if has_remote "$_dep"; then
202                         branch_contains "$_dep" "refs/remotes/$base_remote/$_dep" || _dep_base_update=%
203                 fi
204                 # This can possibly override the remote check result;
205                 # we want to sync with our base first
206                 branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_update=:
207         fi
208
209         if [ -n "$_dep_base_update" ]; then
210                 # _dep needs to be synced with its base/remote
211                 echo "$_dep_base_update $_dep $_depchain"
212                 _ret=1
213         elif [ -n "$_name" ] && ! branch_contains "refs/top-bases/$_name" "$_dep"; then
214                 # Some new commits in _dep
215                 echo "$_dep $_depchain"
216                 _ret=1
217         fi
218 }
219
220 # needs_update NAME
221 # This function is recursive; it outputs reverse path from NAME
222 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
223 # inner paths first. Innermost name can be ':' if the head is
224 # not in sync with the base or '%' if the head is not in sync
225 # with the remote (in this order of priority).
226 # It will also return non-zero status if NAME needs update.
227 # If needs_update() hits missing dependencies, it will append
228 # them to space-separated $missing_deps list and skip them.
229 needs_update()
230 {
231         recurse_deps branch_needs_update "$@"
232 }
233
234 # branch_empty NAME
235 branch_empty()
236 {
237         [ -z "$(git diff-tree "refs/top-bases/$1" "$1" -- | fgrep -v "  .top")" ]
238 }
239
240 # switch_to_base NAME [SEED]
241 switch_to_base()
242 {
243         _base="refs/top-bases/$1"; _seed="$2"
244         # We have to do all the hard work ourselves :/
245         # This is like git checkout -b "$_base" "$_seed"
246         # (or just git checkout "$_base"),
247         # but does not create a detached HEAD.
248         git read-tree -u -m HEAD "${_seed:-$_base}"
249         [ -z "$_seed" ] || git update-ref "$_base" "$_seed"
250         git symbolic-ref HEAD "$_base"
251 }
252
253 # Show the help messages.
254 do_help()
255 {
256         if [ -z "$1" ] ; then
257                 # This is currently invoked in all kinds of circumstances,
258                 # including when the user made a usage error. Should we end up
259                 # providing more than a short help message, then we should
260                 # differentiate.
261                 # Petr's comment: http://marc.info/?l=git&m=122718711327376&w=2
262
263                 ## Build available commands list for help output
264
265                 cmds=
266                 sep=
267                 for cmd in "@cmddir@"/tg-*; do
268                         ! [ -r "$cmd" ] && continue
269                         # strip directory part and "tg-" prefix
270                         cmd="$(basename "$cmd")"
271                         cmd="${cmd#tg-}"
272                         cmds="$cmds$sep$cmd"
273                         sep="|"
274                 done
275
276                 echo "TopGit v$TG_VERSION - A different patch queue manager"
277                 echo "Usage: tg [-r REMOTE] ($cmds|help) ..."
278         elif [ -r "@cmddir@"/tg-$1 ] ; then
279                 setup_pager
280                 @cmddir@/tg-$1 -h 2>&1 || :
281                 echo
282                 if [ -r "@sharedir@/tg-$1.txt" ] ; then
283                         cat "@sharedir@/tg-$1.txt"
284                 fi
285         else
286                 echo "`basename $0`: no help for $1" 1>&2
287                 do_help
288                 exit 1
289         fi
290 }
291
292 ## Pager stuff
293
294 # isatty FD
295 isatty()
296 {
297         test -t $1
298 }
299
300 # setup_pager
301 # Spawn pager process and redirect the rest of our output to it
302 setup_pager()
303 {
304         isatty 1 || return 0
305
306         # TG_PAGER = GIT_PAGER | PAGER | less
307         # NOTE: GIT_PAGER='' is significant
308         TG_PAGER=${GIT_PAGER-${PAGER-less}}
309
310         [ -z "$TG_PAGER"  -o  "$TG_PAGER" = "cat" ]  && return 0
311
312
313         # now spawn pager
314         export LESS="${LESS:-FRSX}"     # as in pager.c:pager_preexec()
315
316         _pager_fifo_dir="$(mktemp -t -d tg-pager-fifo.XXXXXX)"
317         _pager_fifo="$_pager_fifo_dir/0"
318         mkfifo -m 600 "$_pager_fifo"
319
320         "$TG_PAGER" < "$_pager_fifo" &
321         exec > "$_pager_fifo"           # dup2(pager_fifo.in, 1)
322
323         # this is needed so e.g. `git diff` will still colorize it's output if
324         # requested in ~/.gitconfig with color.diff=auto
325         export GIT_PAGER_IN_USE=1
326
327         # atexit(close(1); wait pager)
328         trap "exec >&-; rm \"$_pager_fifo\"; rmdir \"$_pager_fifo_dir\"; wait" EXIT
329 }
330
331 ## Startup
332
333 [ -d "@cmddir@" ] ||
334         die "No command directory: '@cmddir@'"
335
336 ## Initial setup
337
338 set -e
339 git_dir="$(git rev-parse --git-dir)"
340 root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
341 # Make sure root_dir doesn't end with a trailing slash.
342 root_dir="${root_dir%/}"
343 base_remote="$(git config topgit.remote 2>/dev/null)" || :
344 tg="tg"
345 # make sure merging the .top* files will always behave sanely
346 setup_ours
347 setup_hook "pre-commit"
348
349 ## Dispatch
350
351 # We were sourced from another script for our utility functions;
352 # this is set by hooks.  Skip the rest of the file.  A simple return doesn't
353 # work as expected in every shell.  See http://bugs.debian.org/516188
354 if [ -z "$tg__include" ]; then
355
356 if [ "$1" = "-r" ]; then
357         shift
358         if [ -z "$1" ]; then
359                 echo "Option -r requires an argument." >&2
360                 do_help
361                 exit 1
362         fi
363         base_remote="$1"; shift
364         tg="$tg -r $base_remote"
365 fi
366
367 cmd="$1"
368 [ -n "$cmd" ] || { do_help; exit 1; }
369 shift
370
371 case "$cmd" in
372 help|--help|-h)
373         do_help "$1"
374         exit 0;;
375 --hooks-path)
376         # Internal command
377         echo "@hooksdir@";;
378 *)
379         [ -r "@cmddir@"/tg-$cmd ] || {
380                 echo "Unknown subcommand: $cmd" >&2
381                 do_help
382                 exit 1
383         }
384         . "@cmddir@"/tg-$cmd;;
385 esac
386
387 fi
388
389 # vim:noet